// -*- c++ -*-
// Generated by gtkmmproc -- DO NOT MODIFY!
#ifndef _GTKMM_NUMERABLEICON_H
#define _GTKMM_NUMERABLEICON_H

#include <gtkmmconfig.h>


#include <glibmm.h>

/* Copyright (C) 2010 The gtkmm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */


#include <giomm/emblemedicon.h>
#include <gtkmm/stylecontext.h>


#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _GtkNumerableIcon GtkNumerableIcon;
typedef struct _GtkNumerableIconClass GtkNumerableIconClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Gtk
{ class NumerableIcon_Class; } // namespace Gtk
namespace Gtk
{

/** A Gio::Icon that allows numbered emblems.
 *
 * GtkNumerableIcon is a subclass of EmblemedIcon that can show a number or short string as an emblem.
 * The number can be overlayed on top of another emblem, if desired.
 *
 * It supports theming by taking font and color information from a provided StyleContext. See set_style_context().
 *
 * @newin{3,0}
 */

class NumerableIcon : public Gio::EmblemedIcon
{
  
#ifndef DOXYGEN_SHOULD_SKIP_THIS

public:
  typedef NumerableIcon CppObjectType;
  typedef NumerableIcon_Class CppClassType;
  typedef GtkNumerableIcon BaseObjectType;
  typedef GtkNumerableIconClass BaseClassType;

private:  friend class NumerableIcon_Class;
  static CppClassType numerableicon_class_;

private:
  // noncopyable
  NumerableIcon(const NumerableIcon&);
  NumerableIcon& operator=(const NumerableIcon&);

protected:
  explicit NumerableIcon(const Glib::ConstructParams& construct_params);
  explicit NumerableIcon(GtkNumerableIcon* castitem);

#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
  virtual ~NumerableIcon();

#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type()      G_GNUC_CONST;


  static GType get_base_type() G_GNUC_CONST;
#endif

  ///Provides access to the underlying C GObject.
  GtkNumerableIcon*       gobj()       { return reinterpret_cast<GtkNumerableIcon*>(gobject_); }

  ///Provides access to the underlying C GObject.
  const GtkNumerableIcon* gobj() const { return reinterpret_cast<GtkNumerableIcon*>(gobject_); }

  ///Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
  GtkNumerableIcon* gobj_copy();

private:


protected:
  explicit NumerableIcon(const Glib::RefPtr<Gio::Icon>& icon);

  explicit NumerableIcon(const Glib::RefPtr<Gio::Icon>& icon, const Glib::RefPtr<StyleContext>& style_context);

public:
  
  static Glib::RefPtr<NumerableIcon> create(const Glib::RefPtr<Gio::Icon>& icon);


  static Glib::RefPtr<NumerableIcon> create(const Glib::RefPtr<Gio::Icon>& icon, const Glib::RefPtr<StyleContext>& context);


  Glib::RefPtr<StyleContext> get_style_context();
  
  Glib::RefPtr<const StyleContext> get_style_context() const;

  
  void set_style_context(const Glib::RefPtr<StyleContext>& style);

  
  int get_count() const;
  
  void set_count(int count);

  
  Glib::ustring get_label() const;
  
  void set_label(const Glib::ustring& label);

  
  void set_background_gicon(const Glib::RefPtr<Gio::Icon>& icon);

  
  Glib::RefPtr<Gio::Icon> get_background_gicon();
  
  Glib::RefPtr<const Gio::Icon> get_background_gicon() const;

  
  void set_background_icon_name(const Glib::ustring& icon_name);
  
  Glib::ustring get_background_icon_name() const;

  #ifdef GLIBMM_PROPERTIES_ENABLED
/** The count of the emblem currently displayed.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy<int> property_count() ;
#endif //#GLIBMM_PROPERTIES_ENABLED

#ifdef GLIBMM_PROPERTIES_ENABLED
/** The count of the emblem currently displayed.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly<int> property_count() const;
#endif //#GLIBMM_PROPERTIES_ENABLED

  #ifdef GLIBMM_PROPERTIES_ENABLED
/** The label to be displayed over the icon.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy<Glib::ustring> property_label() ;
#endif //#GLIBMM_PROPERTIES_ENABLED

#ifdef GLIBMM_PROPERTIES_ENABLED
/** The label to be displayed over the icon.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly<Glib::ustring> property_label() const;
#endif //#GLIBMM_PROPERTIES_ENABLED

  #ifdef GLIBMM_PROPERTIES_ENABLED
/** The style context to theme the icon appearance.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy< Glib::RefPtr<StyleContext> > property_style_context() ;
#endif //#GLIBMM_PROPERTIES_ENABLED

#ifdef GLIBMM_PROPERTIES_ENABLED
/** The style context to theme the icon appearance.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly< Glib::RefPtr<StyleContext> > property_style_context() const;
#endif //#GLIBMM_PROPERTIES_ENABLED

  #ifdef GLIBMM_PROPERTIES_ENABLED
/** The icon for the number emblem background.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy< Glib::RefPtr<Gio::Icon> > property_background_icon() ;
#endif //#GLIBMM_PROPERTIES_ENABLED

#ifdef GLIBMM_PROPERTIES_ENABLED
/** The icon for the number emblem background.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly< Glib::RefPtr<Gio::Icon> > property_background_icon() const;
#endif //#GLIBMM_PROPERTIES_ENABLED

  #ifdef GLIBMM_PROPERTIES_ENABLED
/** The icon name for the number emblem background.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy<Glib::ustring> property_background_icon_name() ;
#endif //#GLIBMM_PROPERTIES_ENABLED

#ifdef GLIBMM_PROPERTIES_ENABLED
/** The icon name for the number emblem background.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly<Glib::ustring> property_background_icon_name() const;
#endif //#GLIBMM_PROPERTIES_ENABLED


public:

public:
  //C++ methods used to invoke GTK+ virtual functions:

protected:
  //GTK+ Virtual Functions (override these to change behaviour):

  //Default Signal Handlers::


};

} // namespace Gtk


namespace Glib
{
  /** A Glib::wrap() method for this object.
   * 
   * @param object The C instance.
   * @param take_copy False if the result should take ownership of the C instance. True if it should take a new copy or ref.
   * @result A C++ instance that wraps this C instance.
   *
   * @relates Gtk::NumerableIcon
   */
  Glib::RefPtr<Gtk::NumerableIcon> wrap(GtkNumerableIcon* object, bool take_copy = false);
}


#endif /* _GTKMM_NUMERABLEICON_H */

